"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var express_1 = __importDefault(require("express"));
var context_1 = require("../context");
var Server = /** @class */ (function (_super) {
    __extends(Server, _super);
    function Server(props) {
        var _this = _super.call(this, props) || this;
        _this.app = express_1.default();
        _this.shouldComponentUpdate = function (nextProps) {
            if (nextProps.listen !== _this.props.listen ||
                nextProps.port !== _this.props.port) {
                if (nextProps.listen !== _this.props.listen && !nextProps.listen) {
                    if (_this.server)
                        _this.server.close();
                }
                if (nextProps.port !== _this.props.port) {
                    if (nextProps.listen) {
                        if (_this.props.listen) {
                            if (_this.server)
                                _this.server.close();
                        }
                        _this.server = _this.app.listen(nextProps.port);
                        if (_this.props.then)
                            _this.server.on("close", _this.props.then);
                    }
                }
                else {
                    if (nextProps.listen !== _this.props.listen && nextProps.listen) {
                        _this.server = _this.app.listen(nextProps.port);
                        if (_this.props.then)
                            _this.server.on("close", _this.props.then);
                    }
                }
            }
            if (!_this.props.reference && nextProps.reference) {
                nextProps.reference(_this.app, _this.server);
            }
            _this.app.listen();
            return false;
        };
        _this.componentWillUnmount = function () {
            if (_this.server)
                _this.server.close();
        };
        if (props.listen && props.port) {
            _this.server = _this.app.listen(_this.props.port);
            if (props.then)
                _this.server.on("close", props.then);
            if (props.reference)
                props.reference(_this.app, _this.server);
        }
        return _this;
    }
    Server.prototype.render = function () {
        return (react_1.default.createElement(context_1.ApplicationContext.Provider, { value: this.app }, this.props.children));
    };
    return Server;
}(react_1.default.Component));
exports.default = Server;
