import React from "react";
import { RequestHandler } from "express";
export interface MiddlewareProps {
    /**
     * the path the middleware will handle
     */
    path?: string;
    /**
     * middlewares to use.
     * @see {@link http://expressjs.com/en/4x/api.html#middleware-callback-function-examples}
     */
    middlewares: RequestHandler[];
}
declare class Middleware extends React.Component<MiddlewareProps> {
    private router?;
    private routerUpdateIndex;
    routerDidUpdate: () => void;
    render(): JSX.Element;
}
export default Middleware;
