"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var context_1 = require("../context");
var Middleware = /** @class */ (function (_super) {
    __extends(Middleware, _super);
    function Middleware() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.routerUpdateIndex = 0;
        _this.routerDidUpdate = function () {
            var _a, _b;
            if (_this.router) {
                _this.routerUpdateIndex++;
                var currentRouterUpdateIndex_1 = _this.routerUpdateIndex;
                var _c = _this.props, path = _c.path, middlewares = _c.middlewares;
                var resultMiddlewares = middlewares.map(function (originalMiddleware) {
                    var middleware = function (req, res, next) {
                        if (currentRouterUpdateIndex_1 === _this.routerUpdateIndex) {
                            originalMiddleware(req, res, next);
                        }
                    };
                    return middleware;
                });
                if (path) {
                    (_a = _this.router).use.apply(_a, __spreadArrays([path], resultMiddlewares));
                }
                else {
                    (_b = _this.router).use.apply(_b, resultMiddlewares);
                }
            }
        };
        return _this;
    }
    Middleware.prototype.render = function () {
        var _this = this;
        return (react_1.default.createElement(context_1.ApplicationContext.Consumer, null, function (app) {
            return (react_1.default.createElement(context_1.RouterContext.Consumer, null, function (router) {
                if (app || router) {
                    _this.router = (router || app);
                }
                _this.routerDidUpdate();
                return _this.props.children;
            }));
        }));
    };
    return Middleware;
}(react_1.default.Component));
exports.default = Middleware;
