import React from "react";
import { RequestHandler } from "express";
export interface RouteProps {
    /**
     * the path of the route
     */
    path: string;
    /**
     * handle all requests
     */
    all?: RequestHandler;
    /**
     * handle delete request
     */
    delete?: RequestHandler;
    /**
     * handle get request
     */
    get?: RequestHandler;
    /**
     * handle post request
     */
    post?: RequestHandler;
    /**
     * handle put request
     */
    put?: RequestHandler;
}
declare class Route extends React.Component<RouteProps> {
    private router?;
    private routerUpdateIndex;
    private routerDidUpdate;
    componentWillUnmount: () => void;
    render(): JSX.Element;
}
export default Route;
