"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var context_1 = require("../context");
var Route = /** @class */ (function (_super) {
    __extends(Route, _super);
    function Route() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.routerUpdateIndex = 0;
        _this.routerDidUpdate = function () {
            if (_this.router) {
                _this.routerUpdateIndex++;
                var currentRouterUpdateIndex_1 = _this.routerUpdateIndex;
                var _a = _this.props, path = _a.path, all_1 = _a.all, deleteRoute_1 = _a.delete, get_1 = _a.get, post_1 = _a.post, put_1 = _a.put;
                _this.router.all(path, function (req, response, next) {
                    if (currentRouterUpdateIndex_1 === _this.routerUpdateIndex && all_1) {
                        all_1(req, response, next);
                    }
                    else {
                        next();
                    }
                });
                _this.router.delete(path, function (req, response, next) {
                    if (currentRouterUpdateIndex_1 === _this.routerUpdateIndex && deleteRoute_1) {
                        deleteRoute_1(req, response, next);
                    }
                    else {
                        next();
                    }
                });
                _this.router.get(path, function (req, response, next) {
                    if (currentRouterUpdateIndex_1 === _this.routerUpdateIndex && get_1) {
                        get_1(req, response, next);
                    }
                    else {
                        next();
                    }
                });
                _this.router.post(path, function (req, response, next) {
                    if (currentRouterUpdateIndex_1 === _this.routerUpdateIndex && post_1) {
                        post_1(req, response, next);
                    }
                    else {
                        next();
                    }
                });
                _this.router.put(path, function (req, response, next) {
                    if (currentRouterUpdateIndex_1 === _this.routerUpdateIndex && put_1) {
                        put_1(req, response, next);
                    }
                    else {
                        next();
                    }
                });
            }
        };
        _this.componentWillUnmount = function () {
            _this.routerUpdateIndex++;
        };
        return _this;
    }
    Route.prototype.render = function () {
        var _this = this;
        return (react_1.default.createElement(context_1.ApplicationContext.Consumer, null, function (app) {
            return (react_1.default.createElement(context_1.RouterContext.Consumer, null, function (router) {
                if (app || router) {
                    _this.router = (router || app);
                }
                _this.routerDidUpdate();
                return _this.props.children;
            }));
        }));
    };
    return Route;
}(react_1.default.Component));
exports.default = Route;
