"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var express_1 = __importDefault(require("express"));
var context_1 = require("../context");
var Router = /** @class */ (function (_super) {
    __extends(Router, _super);
    function Router() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Router.prototype.render = function () {
        var _this = this;
        return (react_1.default.createElement(context_1.ApplicationContext.Consumer, null, function (app) {
            return (react_1.default.createElement(context_1.RouterContext.Consumer, null, function (router) {
                if (app) {
                    _this.router = express_1.default.Router();
                    (router || app).use(_this.props.path, _this.router);
                    if (_this.props.reference)
                        _this.props.reference(_this.router);
                }
                return (react_1.default.createElement(context_1.RouterContext.Provider, { value: _this.router }, _this.props.children));
            }));
        }));
    };
    return Router;
}(react_1.default.Component));
exports.default = Router;
